base: no longer works on v5.6, require v5.8